
From: William Lee Irwin III <wli@holomorphy.com>

 * Fix slashes in broken Acorn ISO9660 images in fs/isofs/dir.c (Darren Salt)
This fixes Debian BTS #141660.
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=141660

	From: Darren Salt <linux@youmustbejoking.demon.co.uk>
	Message-ID: <4B238BA09A%linux@youmustbejoking.demon.co.uk>
	To: submit@bugs.debian.org
	Subject: Handle '/' in filenames in broken ISO9660 images

[Also applicable to 2.2.x]

There has been for some time a problem with certain CD-ROMs whose images
were generated using a particular tool on Acorn RISC OS.  The problem is
that in certain catalogue entries, the extension separator character '/'
(RISC OS uses '.' and '/' the other way round) was not replaced with '.';
thus Linux cannot properly parse this without this patch, thinking that it
is a directory separator.

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/fs/isofs/dir.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletion(-)

diff -puN fs/isofs/dir.c~fix-handling-of--embedded-in-filenames-in-isofs fs/isofs/dir.c
--- 25/fs/isofs/dir.c~fix-handling-of--embedded-in-filenames-in-isofs	2004-06-13 21:28:45.075120448 -0700
+++ 25-akpm/fs/isofs/dir.c	2004-06-13 21:28:45.079119840 -0700
@@ -64,7 +64,8 @@ int isofs_name_translate(struct iso_dire
 			break;
 
 		/* Convert remaining ';' to '.' */
-		if (c == ';')
+		/* Also '/' to '.' (broken Acorn-generated ISO9660 images) */
+		if (c == ';' || c == '/')
 			c = '.';
 
 		new[i] = c;
_
